package org.metaabm.examples.stupid1;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import java.util.List;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.util.Conditional;

/**
 * Bug Java Implementation.
 * 
 * Generated by AMF for model: StupidModel1.metaabm in project: org.eclipse.amp.amf.examples.ascape 
 */
public class Bug extends CellOccupant {

	/**
	 * Constructs a new Bug.
	 */
	public Bug() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Bug clone = (Bug) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public StupidModel1 getStupidModel1() {
		return (StupidModel1) getScape().getScape();
	}

	public Color getColor() {
		return Color.LIGHT_GRAY;
	}

	/**
	 * Initialize Initialization. Executed once at the beginning of each model run.
	 */
	public void intializeNonFramework() {
		Habitat randomHabitat = (Habitat) ((org.ascape.model.space.Discrete) getStupidModel1()
				.getGrid2D().getSpace()).findRandomAvailable();
		if (randomHabitat != null) {
			if (getHostScape() != ((Agent) randomHabitat).getScape()) {
				die();
				getStupidModel1().getBugScape().add(this);
			}
			moveTo(randomHabitat);
		}
	}

	/**
	 * Bug Rule Rule. Executed every period.
	 */
	public void bugRule() {
		Habitat nearbySpace = (Habitat) ((org.ascape.model.space.Discrete) getStupidModel1()
				.getGrid2D().getSpace()).findRandomAvailable(
				((org.ascape.model.CellOccupant) this).getHostCell(), null,
				false, getStupidModel1().getBugVision());
		if (nearbySpace != null) {
			if (getHostScape() != ((Agent) nearbySpace).getScape()) {
				die();
				getStupidModel1().getBugScape().add(this);
			}
			moveTo(nearbySpace);
		}
	}
	public String getName() {
		if (name == null) {
			return "Bug " + getUID();
		} else {
			return name;
		}
	}
}
