package org.metaabm.examples.stupid1;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import java.util.List;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.util.Conditional;

/**
 * StupidModel1 Java Implementation.
 * 
 * Generated by AMF for model: StupidModel1.metaabm in project: org.eclipse.amp.amf.examples.ascape 
 */
public class StupidModel1 extends Scape {

	/**
	 * The number of bugs to create.
	 */
	private int bugCount = 100;

	/**
	 * The number of habitats to create.
	 */
	private int habitatCount = 0;

	/**
	 * 
	 */
	private int bugVision = 4;

	/**
	 * The size of each dimension.
	 */
	private int[] grid2DDimensions = new int[2];

	/**
	 * The horizontal extent of the space.
	 */
	private int grid2DWidth = 100;

	/**
	 * The vertical extent of the space.
	 */
	private int grid2DHeight = 100;

	/**
	 * 
	 */
	private Scape grid2D = null;

	/**
	 * Constructs a new StupidModel1.
	 */
	public StupidModel1() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			StupidModel1 clone = (StupidModel1) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	org.ascape.model.Scape bugScape;

	/**
	 * Create an instance of Bug that will be used to populate the bugScape.
	 * Overide to customize the prototype, for example to change the views created for a member scape.
	 */
	protected Bug createBugPrototype() {
		return new Bug();
	}

	static int next_vm_id;

	int vm_unique_id;

	/**
	 * Creates the members of StupidModel1. 
	 */
	public void createScape() {
		super.createScape();

		setName("StupidModel1");
		Bug bugProto = createBugPrototype();
		bugScape = new Scape();
		bugScape.setName("Bugs");
		bugScape.setPrototypeAgent(bugProto);
		bugScape.setExecutionOrder(Scape.RULE_ORDER);

		bugScape.setSize(bugCount);
		grid2D = new Scape(new org.ascape.model.space.Array2DMoore());
		grid2D.setExecutionOrder(Scape.RULE_ORDER);
		grid2D.setPrototypeAgent(new Habitat());
		grid2D.setExtent(new org.ascape.model.space.Coordinate2DDiscrete(
				getGrid2DWidth(), getGrid2DHeight()));

		grid2D.setName("Grid 2Ds");
		((CollectionSpace) grid2D.getSpace()).setPeriodic(true);
		add(grid2D);
		org.ascape.model.Scape habitatScape = grid2D;

		add(bugScape);

		bugProto.setHostScape(grid2D);
		grid2D.getRules().clear();

		bugScape.addStatCollector(new org.ascape.util.data.StatCollectorCond(
				getName() + " Population") {
			private static final long serialVersionUID = 684614444640209893L;

			@SuppressWarnings("unused")
			public final boolean meetsCondition(Object object) {
				return true;
			}
		});

		bugScape.addInitialRule(new Rule("Initialize") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((org.metaabm.examples.stupid1.Bug) a).intializeNonFramework();
			}
		});
		bugScape.addRule(new Rule("Bug Rule") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((org.metaabm.examples.stupid1.Bug) a).bugRule();
			}
		});

	}

	/**
	 * Creates UI views for StupidModel1.
	 */
	public void createGraphicViews() {
		super.createGraphicViews();
		{
			org.ascape.view.vis.Overhead2DView grid2DView = new org.ascape.view.vis.Overhead2DView();
			grid2DView.setAgentSize(3);
			grid2D.addView(grid2DView);
			org.ascape.util.vis.DrawFeature habitatStyle2D = new org.metaabm.examples.stupid1.HabitatStyle2D();
			habitatStyle2D.setName("Habitat Style 2D");
			grid2D.addDrawFeature(habitatStyle2D);
			org.ascape.util.vis.DrawFeature bugStyle2D = new org.metaabm.examples.stupid1.BugStyle2D();
			bugStyle2D.setName("Bug Style 2D");
			grid2D.addDrawFeature(bugStyle2D);
			grid2DView.getDrawSelection().setSelected(bugStyle2D, true);
			grid2DView.getDrawSelection().setSelected(habitatStyle2D, true);
			grid2DView.getDrawSelection().setSelected(
					grid2DView.agents_oval_cells_draw_feature, false);
			grid2DView.getDrawSelection().setSelected(
					grid2DView.cells_fill_draw_feature, true);
			grid2DView.getDrawSelection().moveToFront(
					grid2DView.cells_fill_draw_feature);
		}
		{
			org.ascape.view.vis.ChartView chart = new org.ascape.view.vis.ChartView();
			addView(chart);
			//if (getRunner().getEnvironment() instanceof org.ascape.runtime.applet.AppletEnvironment) {
			//    chart.getChart().getLegend().setAnchor(com.jrefinery.chart.Legend.SOUTH);
			//}
			Graphics dummyGraphics = new BufferedImage(10, 10,
					BufferedImage.TYPE_INT_RGB).getGraphics();

			final StupidModel1 bugScape = new StupidModel1();
			bugScape.setRunner(new org.ascape.runtime.NonGraphicRunner());
			Bug bug = new Bug() {
				public void requestUpdate() {
				}
				public StupidModel1 getStupidModel1() {
					return bugScape;
				}
			};
			bugScape.add(bug);
			org.ascape.model.HostCell bugHost = new org.ascape.model.HostCell() {
				public void requestUpdate() {
				}
			};
			bugHost.setOccupant((org.ascape.model.CellOccupant) bug);

			BugStyle2D bugStyle2D = new BugStyle2D();

			final StupidModel1 habitatScape = new StupidModel1();
			habitatScape.setRunner(new org.ascape.runtime.NonGraphicRunner());
			Habitat habitat = new Habitat() {
				public void requestUpdate() {
				}
				public StupidModel1 getStupidModel1() {
					return habitatScape;
				}
			};
			habitatScape.add(habitat);

			HabitatStyle2D habitatStyle2D = new HabitatStyle2D();
		}
	}

	public void scapeSetup(ScapeEvent scapeEvent) {
		//Set the size of the scape populations, e.g. for mutable scapes that need to have their size reset

		bugScape.setSize(bugCount);
	}

	/**
	 * Returns the Scape containing Bugs.
	 */
	public org.ascape.model.Scape getBugScape() {
		return bugScape;
	}

	public static void main(String[] args) {
		(new org.ascape.runtime.swing.SwingRunner()).open(
				"org.metaabm.examples.stupid1.StupidModel1", args);
	}

	public Color getColor() {
		return Color.LIGHT_GRAY;
	}
	/**
	 * Gets the Bug Count property for StupidModel1.
	 * @return The number of bugs to create.
	 */
	public int getBugCount() {
		return bugCount;
	}

	/**
	 * Sets the Bug Count property for StupidModel1.
	 * The number of bugs to create.
	 * @param _bugCount the new Bug Count value
	 */
	public void setBugCount(int _bugCount) {
		bugCount = _bugCount;
	}

	/**
	 * Gets the Habitat Count property for StupidModel1.
	 * @return The number of habitats to create.
	 */
	public int getHabitatCount() {
		return habitatCount;
	}

	/**
	 * Sets the Habitat Count property for StupidModel1.
	 * The number of habitats to create.
	 * @param _habitatCount the new Habitat Count value
	 */
	public void setHabitatCount(int _habitatCount) {
		habitatCount = _habitatCount;
	}

	/**
	 * Gets the Bug Vision property for StupidModel1.
	 * @return 
	 */
	public int getBugVision() {
		return bugVision;
	}

	/**
	 * Sets the Bug Vision property for StupidModel1.
	 * 
	 * @param _bugVision the new Bug Vision value
	 */
	public void setBugVision(int _bugVision) {
		bugVision = _bugVision;
	}

	/**
	 * Gets the Dimensions property for Grid 2D.
	 * @return The size of each dimension.
	 */
	public int[] getGrid2DDimensions() {
		return grid2DDimensions;
	}

	/**
	 * Sets the Dimensions property for Grid 2D.
	 * The size of each dimension.
	 * @param _grid2DDimensions the new Dimensions value
	 */
	public void setGrid2DDimensions(int[] _grid2DDimensions) {
		grid2DDimensions = _grid2DDimensions;
	}

	/**
	 * Gets the Width property for Grid 2D.
	 * @return The horizontal extent of the space.
	 */
	public int getGrid2DWidth() {
		return grid2DWidth;
	}

	/**
	 * Sets the Width property for Grid 2D.
	 * The horizontal extent of the space.
	 * @param _grid2DWidth the new Width value
	 */
	public void setGrid2DWidth(int _grid2DWidth) {
		grid2DWidth = _grid2DWidth;
	}

	/**
	 * Gets the Height property for Grid 2D.
	 * @return The vertical extent of the space.
	 */
	public int getGrid2DHeight() {
		return grid2DHeight;
	}

	/**
	 * Sets the Height property for Grid 2D.
	 * The vertical extent of the space.
	 * @param _grid2DHeight the new Height value
	 */
	public void setGrid2DHeight(int _grid2DHeight) {
		grid2DHeight = _grid2DHeight;
	}

	/**
	 * Gets the Grid 2D property for StupidModel1.
	 * @return 
	 */
	public Scape getGrid2D() {
		return grid2D;
	}

	/**
	 * Sets the Grid 2D property for StupidModel1.
	 * 
	 * @param _grid2D the new Grid 2D value
	 */
	public void setGrid2D(Scape _grid2D) {
		grid2D = _grid2D;
	}

	public String getName() {
		if (name == null) {
			return "StupidModel1 " + getUID();
		} else {
			return name;
		}
	}
}
