package org.metaabm.examples.stupid2;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import java.util.List;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.util.Conditional;

/**
 * Bug Java Implementation.
 * 
 * Generated by AMF for model: StupidModel2.metaabm in project: org.eclipse.amp.amf.examples.ascape 
 */
public class Bug extends CellOccupant {

	/**
	 * 
	 */
	private int size = 0;

	/**
	 * Constructs a new Bug.
	 */
	public Bug() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Bug clone = (Bug) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public StupidModel2 getStupidModel2() {
		return (StupidModel2) getScape().getScape();
	}

	public Color getColor() {
		return Color.LIGHT_GRAY;
	}

	/**
	 * Initialize Initialization. Executed once at the beginning of each model run.
	 */
	public void intializeNonFramework() {
		Habitat randomHabitat = (Habitat) ((org.ascape.model.space.Discrete) getStupidModel2()
				.getGrid2D().getSpace()).findRandomAvailable();
		if (randomHabitat != null) {
			if (getHostScape() != ((Agent) randomHabitat).getScape()) {
				die();
				getStupidModel2().getBugScape().add(this);
			}
			moveTo(randomHabitat);
		}
	}

	/**
	 * Random Movement Rule. Executed every period.
	 */
	public void randomMovement() {
		Habitat nearbySpace = (Habitat) ((org.ascape.model.space.Discrete) getStupidModel2()
				.getGrid2D().getSpace()).findRandomAvailable(
				((org.ascape.model.CellOccupant) this).getHostCell(), null,
				false, getStupidModel2().getBugVision());
		if (nearbySpace != null) {
			if (getHostScape() != ((Agent) nearbySpace).getScape()) {
				die();
				getStupidModel2().getBugScape().add(this);
			}
			moveTo(nearbySpace);
		}
	}

	/**
	 * Grow Rule. Executed every period.
	 */
	public void grow() {
		int growIncrementSize = getSize() + 1;

		setSize(growIncrementSize);
	}
	/**
	 * Gets the Size property for Bug.
	 * @return 
	 */
	public int getSize() {
		return size;
	}

	/**
	 * Sets the Size property for Bug.
	 * 
	 * @param _size the new Size value
	 */
	public void setSize(int _size) {
		size = _size;
	}

	public String getName() {
		if (name == null) {
			return "Bug " + getUID();
		} else {
			return name;
		}
	}
}
