package org.metaabm.examples.stupid3;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import java.util.List;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.util.Conditional;

/**
 * Habitat Java Implementation.
 * 
 * Generated by AMF for model: StupidModel3.metaabm in project: org.eclipse.amp.amf.examples.ascape 
 */
public class Habitat extends HostCell {

	/**
	 * 
	 */
	private double foodAvailability = 0.0;

	/**
	 * 
	 */
	private double maximumFoodProductionRate = 0.01;

	/**
	 * Constructs a new Habitat.
	 */
	public Habitat() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Habitat clone = (Habitat) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public StupidModel3 getStupidModel3() {
		return (StupidModel3) getScape().getScape();
	}

	public Color getColor() {
		return Color.LIGHT_GRAY;
	}

	/**
	 * determindFoodProduction Rule. Executed every period.
	 */
	public void determindFoodProduction() {
		double calculateFoodProductionRate = randomInRange(0,
				getMaximumFoodProductionRate());

		double newFoodProductionValue = getFoodAvailability()
				+ calculateFoodProductionRate;

		setFoodAvailability(newFoodProductionValue);
	}
	/**
	 * Gets the FoodAvailability property for Habitat.
	 * @return 
	 */
	public double getFoodAvailability() {
		return foodAvailability;
	}

	/**
	 * Sets the FoodAvailability property for Habitat.
	 * 
	 * @param _foodAvailability the new FoodAvailability value
	 */
	public void setFoodAvailability(double _foodAvailability) {
		foodAvailability = _foodAvailability;
	}

	/**
	 * Gets the MaximumFoodProductionRate property for Habitat.
	 * @return 
	 */
	public double getMaximumFoodProductionRate() {
		return maximumFoodProductionRate;
	}

	/**
	 * Sets the MaximumFoodProductionRate property for Habitat.
	 * 
	 * @param _maximumFoodProductionRate the new MaximumFoodProductionRate value
	 */
	public void setMaximumFoodProductionRate(double _maximumFoodProductionRate) {
		maximumFoodProductionRate = _maximumFoodProductionRate;
	}

	public String getName() {
		if (name == null) {
			return "Habitat " + getUID();
		} else {
			return name;
		}
	}
}
