package org.metaabm.examples.stupid5;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;

import java.util.List;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.util.Conditional;

/**
 * Bug Java Implementation.
 * 
 * Generated by AMF for model: StupidModel5.metaabm in project: org.eclipse.amp.amf.examples.ascape 
 */
public class Bug extends CellOccupant {

	/**
	 * 
	 */
	private double size = 0.0;

	/**
	 * 
	 */
	private double consumption = 0.0;

	/**
	 * 
	 */
	private double maxConsumption = 0.2;

	/**
	 * Constructs a new Bug.
	 */
	public Bug() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Bug clone = (Bug) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public StupidModel5 getStupidModel5() {
		return (StupidModel5) getScape().getScape();
	}

	public Color getColor() {
		return Color.LIGHT_GRAY;
	}

	/**
	 * Initialize Initialization. Executed once at the beginning of each model run.
	 */
	public void intializeNonFramework() {
		Habitat randomHabitat = (Habitat) ((org.ascape.model.space.Discrete) getStupidModel5()
				.getGrid2D().getSpace()).findRandomAvailable();
		if (randomHabitat != null) {
			if (getHostScape() != ((Agent) randomHabitat).getScape()) {
				die();
				getStupidModel5().getBugScape().add(this);
			}
			moveTo(randomHabitat);
		}
	}

	/**
	 * Random Movement Rule. Executed every period.
	 */
	public void randomMovement() {
		Conditional nearbySpaceCondition = new Conditional() {
			private static final long serialVersionUID = 6846144446402098985L;
			public boolean meetsCondition(Object nearbySpaceCell) {
				nearbySpaceCell = ((org.ascape.model.HostCell) nearbySpaceCell)
						.getOccupant();
				if (nearbySpaceCell instanceof Bug) {
					return true;
				} else {
					return false;
				}
			}
		};
		Location nearbySpaceLocation = ((org.ascape.model.space.Discrete) getStupidModel5()
				.getGrid2D().getSpace()).findRandomAvailable(
				((org.ascape.model.CellOccupant) this).getHostCell(),
				nearbySpaceCondition, false, getStupidModel5().getBugVision());
		if (nearbySpaceLocation != null) {
			Bug nearbySpace = (Bug) ((org.ascape.model.HostCell) nearbySpaceLocation)
					.getOccupant();
			if (nearbySpace != null) {
				moveTo(((org.ascape.model.CellOccupant) nearbySpace)
						.getHostCell());
			}
		}
	}

	/**
	 * Grow Rule. Executed every period.
	 */
	public void grow() {
		Habitat habitat = (Habitat) getHostCell();
		double availability = habitat.getFoodAvailability();
		double consumption = availability < getMaxConsumption()
				? availability
				: getMaxConsumption();
		setSize(getSize() + consumption);
		habitat.setFoodAvailability(availability - consumption);

	}

	/**
	 * 
	 */
	public void consumeFood() {
	}

	/**
	 * Gets the Size property for Bug.
	 * @return 
	 */
	public double getSize() {
		return size;
	}

	/**
	 * Sets the Size property for Bug.
	 * 
	 * @param _size the new Size value
	 */
	public void setSize(double _size) {
		size = _size;
	}

	/**
	 * Gets the Consumption property for Bug.
	 * @return 
	 */
	public double getConsumption() {
		return consumption;
	}

	/**
	 * Sets the Consumption property for Bug.
	 * 
	 * @param _consumption the new Consumption value
	 */
	public void setConsumption(double _consumption) {
		consumption = _consumption;
	}

	/**
	 * Gets the Max Consumption property for Bug.
	 * @return 
	 */
	public double getMaxConsumption() {
		return maxConsumption;
	}

	/**
	 * Sets the Max Consumption property for Bug.
	 * 
	 * @param _maxConsumption the new Max Consumption value
	 */
	public void setMaxConsumption(double _maxConsumption) {
		maxConsumption = _maxConsumption;
	}

	public String getName() {
		if (name == null) {
			return "Bug " + getUID();
		} else {
			return name;
		}
	}
}
