package edu.brook;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * Player Java Implementation.
 * 
 * Generated by AMF for model: DemographicPrisoner_sDilemma.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class Player extends CellOccupant {

	/**
	 * 
	 */
	private boolean cooperate = false;

	/**
	 * 
	 */
	private int age = 0;

	/**
	 * 
	 */
	private int wealth = 0;

	/**
	 * Constructs a new Player.
	 */
	public Player() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Player clone = (Player) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public DemographicPrisonersDilemma getDemographicPrisoner_sDilemma() {
		return (DemographicPrisonersDilemma) getScape().getScape();
	}

	/**
	 * Initialize Initialization. Executed once at the beginning of each model run.
	 */
	public void intializeNonFramework() {
		setWealth(getDemographicPrisoner_sDilemma().getInitialWealth());
		int randomToMaxAge = randomToLimit(getDemographicPrisoner_sDilemma()
				.getMaximumAge());
		boolean randomStrategy = getRandom().nextBoolean();
		setAge(randomToMaxAge);
		setCooperate(randomStrategy);
	}

	/**
	 * Move To Random Location Initialization. Executed once at the beginning of each model run.
	 */
	public void moveToRandomLocation() {
		PlayCell randomCell2 = (PlayCell) ((org.ascape.model.space.Discrete) getDemographicPrisoner_sDilemma()
				.getGameSpace().getSpace()).findRandomAvailable();
		if (randomCell2 != null) {
			if (getHostScape() != ((Agent) randomCell2).getScape()) {
				die();
				getDemographicPrisoner_sDilemma().getPlayerScape().add(this);
			}
			moveTo(randomCell2);
		}
	}

	/**
	 * Random Walk Rule. Executed every period.
	 */
	public void randomWalk() {
		PlayCell randomNeighbor = (PlayCell) ((org.ascape.model.space.Discrete) getDemographicPrisoner_sDilemma()
				.getGameSpace().getSpace())
				.findRandomAvailableNeighbor(((org.ascape.model.CellOccupant) this)
						.getHostCell());
		if (randomNeighbor != null) {
			if (getHostScape() != ((Agent) randomNeighbor).getScape()) {
				die();
				getDemographicPrisoner_sDilemma().getPlayerScape().add(this);
			}
			moveTo(randomNeighbor);
		}
	}

	/**
	 * Play Neighbor Rule. Executed every period.
	 */
	public void playNeighbor() {
		Conditional otherPlayerCondition = new Conditional() {
			private static final long serialVersionUID = 6846144446402098985L;
			public boolean meetsCondition(Object otherPlayerCell) {
				if (otherPlayerCell instanceof Player) {
					return true;
				} else {
					return false;
				}
			}
		};
		Player otherPlayer = (Player) ((org.ascape.model.space.Discrete) getDemographicPrisoner_sDilemma()
				.getGameSpace().getSpace()).findRandomNeighbor(this,
				otherPlayerCondition);
		if (otherPlayer != null) {
			if ((otherPlayer.isCooperate() && isCooperate())) {
				int valueWealthAddPayoffCooperateCooperate = getWealth()
						+ getDemographicPrisoner_sDilemma().getPayoffCC();
				int valueWealthAddPayoffCooperateCooperateCopy = otherPlayer
						.getWealth()
						+ otherPlayer.getDemographicPrisoner_sDilemma()
								.getPayoffCC();
				setWealth(valueWealthAddPayoffCooperateCooperate);
				otherPlayer
						.setWealth(valueWealthAddPayoffCooperateCooperateCopy);
			}
			if ((otherPlayer.isCooperate() && !isCooperate())) {
				int valueWealthAddPayoffDefectCooperate = getWealth()
						+ getDemographicPrisoner_sDilemma().getPayoffDC();
				int valueWealthAddPayoffCooperateDefectCopy = otherPlayer
						.getWealth()
						+ otherPlayer.getDemographicPrisoner_sDilemma()
								.getPayoffCD();
				setWealth(valueWealthAddPayoffDefectCooperate);
				otherPlayer.setWealth(valueWealthAddPayoffCooperateDefectCopy);
			}
			if ((!otherPlayer.isCooperate() && isCooperate())) {
				int valueWealthAddPayoffCooperateDefect = getWealth()
						+ getDemographicPrisoner_sDilemma().getPayoffCD();
				int valueWealthAddPayoffDefectCooperateCopy = otherPlayer
						.getWealth()
						+ otherPlayer.getDemographicPrisoner_sDilemma()
								.getPayoffDC();
				setWealth(valueWealthAddPayoffCooperateDefect);
				otherPlayer.setWealth(valueWealthAddPayoffDefectCooperateCopy);
			}
			if ((!isCooperate() && !otherPlayer.isCooperate())) {
				int valueWealthAddPayoffDefectDefect = getWealth()
						+ getDemographicPrisoner_sDilemma().getPayoffDD();
				int valueWealthAddPayoffDefectDefectCopy = otherPlayer
						.getWealth()
						+ otherPlayer.getDemographicPrisoner_sDilemma()
								.getPayoffDD();
				setWealth(valueWealthAddPayoffDefectDefect);
				otherPlayer.setWealth(valueWealthAddPayoffDefectDefectCopy);
			}
		}
	}

	/**
	 * Update Age Rule. Executed every period.
	 */
	public void updateAge() {
		int incrementAge = getAge() + 1;
		setAge(incrementAge);
	}

	/**
	 * Fission Rule Rule. Executed every period.
	 */
	public void fissionRule() {
		if (getWealth() >= getDemographicPrisoner_sDilemma().getFissionWealth()) {
			PlayCell birthLocation = (PlayCell) ((org.ascape.model.space.Discrete) getDemographicPrisoner_sDilemma()
					.getGameSpace().getSpace())
					.findRandomAvailableNeighbor(((org.ascape.model.CellOccupant) this)
							.getHostCell());
			if (birthLocation != null) {
				Player createAgents = (Player) getDemographicPrisoner_sDilemma()
						.getPlayerScape().getSpace().newLocation(false);
				if (createAgents.getHostScape() != ((Agent) birthLocation)
						.getScape()) {
					die();
					getDemographicPrisoner_sDilemma().getPlayerScape().add(
							createAgents);
				}
				createAgents.moveTo(birthLocation);
				createAgents.setWealth(getDemographicPrisoner_sDilemma()
						.getInheiritedWealth());
				double valueRandomUnit = getRandom().nextDouble();
				int wealthChildWealth = getWealth()
						- createAgents.getDemographicPrisoner_sDilemma()
								.getInheiritedWealth();
				if (valueRandomUnit < createAgents
						.getDemographicPrisoner_sDilemma().getMutationRate()) {
					boolean valueRandomBoolean = getRandom().nextBoolean();
					createAgents.setCooperate(valueRandomBoolean);
				}
				if (!(valueRandomUnit < createAgents
						.getDemographicPrisoner_sDilemma().getMutationRate())) {
					createAgents.setCooperate(isCooperate());
				}
				setWealth(wealthChildWealth);
			}
		}
	}

	/**
	 * Die At Age Rule. Executed every period.
	 */
	public void dieAtAge() {
		if (getAge() > getDemographicPrisoner_sDilemma().getDeathAge()) {
			die();
		}
	}

	/**
	 * Die At Wealth 0 Rule. Executed every period.
	 */
	public void dieAtWealth0() {
		if (getWealth() < 0) {
			die();
		}
	}
	/**
	 * Gets the Cooperate property for Player.
	 * @return 
	 */
	public boolean isCooperate() {
		return cooperate;
	}

	/**
	 * Sets the Cooperate property for Player.
	 * 
	 * @param _cooperate the new Cooperate value
	 */
	public void setCooperate(boolean _cooperate) {
		cooperate = _cooperate;
	}

	/**
	 * Gets the Age property for Player.
	 * @return 
	 */
	public int getAge() {
		return age;
	}

	/**
	 * Sets the Age property for Player.
	 * 
	 * @param _age the new Age value
	 */
	public void setAge(int _age) {
		age = _age;
	}

	/**
	 * Gets the Wealth property for Player.
	 * @return 
	 */
	public int getWealth() {
		return wealth;
	}

	/**
	 * Sets the Wealth property for Player.
	 * 
	 * @param _wealth the new Wealth value
	 */
	public void setWealth(int _wealth) {
		wealth = _wealth;
	}

	public String getName() {
		if (name == null) {
			return "Player " + getUID();
		} else {
			return name;
		}
	}
}
