package name.milesparker.epi.contact;

import org.eclipse.amp.escape.ascape.agf3d.GEF3DView;

/**
 * Epidemic Java Implementation.
 * A simple model of epidemic dynamics. We define individual agents with different disease states. The progression of disease moves from succeptible to exposed to infectious (either symptomatic or asymptomatic) to some outcome state. Agents can transmit infection to their immediate neighbors. 

 For some background on the general approach, see Joshua M. Epstein. "Generative Social Science". 2006. Princeton. 

 Copyright 2009, Miles Parker. Released under Eclipse Public License. All uses should be attributed.
 * Generated by AMF for model: EpidemicContact.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class Epidemic3D extends Epidemic {

	public void createGraphicViews() {
		addView(new GEF3DView());
	}
}
