package name.milesparker.infon;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * Infon Java Implementation.
 * 
 * Generated by AMF for model: Infon.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class Infon extends CellOccupant {

	/**
	 * Constructs a new Infon.
	 */
	public Infon() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Infon clone = (Infon) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public InfonModel getInfonModel() {
		return (InfonModel) getScape().getScape();
	}

	/**
	 * Initialize Initialization. Executed once at the beginning of each model run.
	 */
	public void intializeNonFramework() {
		Object infon = (Object) getInfonModel().getSpace2D().getSpace()
				.findRandom();
		if (infon != null) {
			moveTo(((Coordinate) infon));
		}
	}

	/**
	 * Infon Rule Rule. Executed every period.
	 */
	public void infonRule() {
		Conditional infonCopyCondition = new Conditional() {
			private static final long serialVersionUID = 6846144446402098985L;
			public boolean meetsCondition(Object infonCopyCell) {
				if (infonCopyCell instanceof Infon) {
					return true;
				} else {
					return false;
				}
			}
		};
		Infon infonCopy = (Infon) getInfonModel().getSpace2D().getSpace()
				.findNearest(this, infonCopyCondition, false, Double.MAX_VALUE);
		if (infonCopy != null) {
			moveTo(((org.ascape.model.CellOccupant) infonCopy).getHostCell());
		}
	}
	public String getName() {
		if (name == null) {
			return "Infon " + getUID();
		} else {
			return name;
		}
	}
}
