package name.milesparker.infon;

import org.ascape.util.vis.ColorFeature;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Display;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.ColorConstants;

import org.eclipse.jface.viewers.IColorProvider;

/**
 * Infon Basic Style Java Implementation.
 * 
 * Generated by AMF for model: Infon.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class InfonBasicStyleColorProvider implements IColorProvider {

	private static IColorProvider singleton;

	/**
	 * Provides a color for Infon based on wether we want to fill or not.
	 * 
	 * @param object the agent
	 * @return	the foreground color for the element, or <code>null</code> 
	 *   to use the default foreground color
	 */
	public Color getColor(Object object, boolean fill) {
		Color color = null;
		Color fillColor = null;
		Color outlineColor = null;

		Infon rootActGroup = (Infon) object;
		Infon basicStyleRule = rootActGroup;
		fillColor = ColorConstants.blue;
		if (fill) {
			return fillColor;
		} else {
			return outlineColor;
		}
	}

	/**
	 * Provides a foreground color for the given Infon.
	 * 
	 * @param object the agent
	 * @return	the foreground color for the element, or <code>null</code> 
	 *   to use the default foreground color
	 */
	public Color getForeground(Object object) {
		Color color = getColor(object, false);
		if (color != null) {
			return color;
		}
		//try to see if we have a fill color, if we do, we'll paint the whole agent that color.
		color = getColor(object, true);
		if (color != null) {
			return color;
		}
		return ColorFeature.BLACK;
	}

	/**
	 * Provides a background color for the given Infon.
	 * 
	 * @param object the agent
	 * @return	the background color for the element, or <code>null</code> 
	 *   to use the default background color
	 */
	public Color getBackground(Object object) {
		Color color = getColor(object, true);
		if (color != null) {
			return color;
		}
		//if no fill color, just return white
		return ColorFeature.WHITE;
	}

	public static IColorProvider getDefault() {
		if (singleton == null) {
			singleton = new InfonBasicStyleColorProvider();
		}
		return singleton;
	}
}
