package name.milesparker.infon;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * Infon Model Java Implementation.
 * 
 * Generated by AMF for model: Infon.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class InfonModel extends Scape implements IGraphicsAdapted {

	/**
	 * The number of infons to create.
	 */
	private int infonCount = 100;

	/**
	 * The size of each dimension.
	 */
	private int[] space2DDimensions = new int[2];

	/**
	 * The horizontal extent of the space.
	 */
	private int space2DWidth = 100;

	/**
	 * The vertical extent of the space.
	 */
	private int space2DHeight = 100;

	/**
	 * 
	 */
	private Scape space2D = null;

	/**
	 * Constructs a new Infon Model.
	 */
	public InfonModel() {
	}

	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			InfonModel clone = (InfonModel) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	org.ascape.model.Scape infonScape;

	/**
	 * Create an instance of Infon that will be used to populate the infonScape.
	 * Overide to customize the prototype, for example to change the views created for a member scape.
	 */
	protected Infon createInfonPrototype() {
		return new Infon();
	}

	static int next_vm_id;

	int vm_unique_id;

	/**
	 * Creates the members of Infon Model. 
	 */
	public void createScape() {
		super.createScape();

		setName("Infon Model");
		Infon infonProto = createInfonPrototype();
		infonScape = new Scape();
		infonScape.setName("Infons");
		infonScape.setPrototypeAgent(infonProto);
		infonScape.setExecutionOrder(Scape.RULE_ORDER);
		infonScape.setSize(infonCount);
		space2D = new Scape(new org.ascape.model.space.Continuous2D());
		space2D.setName("Space 2Ds");
		space2D.setExtent(new org.ascape.model.space.Coordinate2DContinuous(
				getSpace2DWidth(), getSpace2DHeight()));

		((CollectionSpace) space2D.getSpace()).setPeriodic(false);
		space2D.setPrototypeAgent(new Infon());

		infonScape.setSpace(new org.ascape.model.space.SubContinuous2D());
		infonScape.setSuperScape(space2D);

		add(space2D);

		add(infonScape);

		infonScape.addStatCollector(new org.ascape.util.data.StatCollectorCond(
				getName() + " Population") {
			private static final long serialVersionUID = 684614444640209893L;

			@SuppressWarnings("unused")
			public final boolean meetsCondition(Object object) {
				return true;
			}
		});

		infonScape.addInitialRule(new Rule("Initialize") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((name.milesparker.infon.Infon) a).intializeNonFramework();
			}
		});
		infonScape.addRule(new Rule("Infon Rule") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((name.milesparker.infon.Infon) a).infonRule();
			}
		});

	}

	/**
	 * Creates UI views for Infon Model.
	 */
	public void createGraphicViews() {
		super.createGraphicViews();
		ChartView chart = new ChartView();

		final InfonModel infonScape = new InfonModel();
		infonScape.setRunner(new NonGraphicRunner());
		Infon infon = new Infon() {
			public void requestUpdate() {
			}
			public InfonModel getInfonModel() {
				return infonScape;
			}
		};
		infonScape.add(infon);
		HostCell infonHost = new HostCell() {
			public void requestUpdate() {
			}
		};
		infonHost.setOccupant((CellOccupant) infon);

		IColorProvider infonBasicStyleColorProvider = new InfonBasicStyleColorProvider();
		addView(chart);
		addView(new GEFView());
	}

	public void scapeSetup(ScapeEvent scapeEvent) {
		//Set the size of the scape populations, e.g. for mutable scapes that need to have their size reset

		infonScape.setSize(infonCount);
	}

	/**
	 * Returns the Scape containing Infons.
	 */
	public org.ascape.model.Scape getInfonScape() {
		return infonScape;
	}

	public IGraphicsAdapter getGraphicsAdapter() {
		return InfonModelGraphicsAdapter.getDefault();
	}

	private Color getInferredChartColor(Object agent,
			IColorProvider colorProvider) {
		Color color = colorProvider.getForeground(agent);
		if (color == ColorFeature.BLACK) {
			color = ColorFeatureConcrete.createHSB(
					(float) java.lang.Math.random() * 360f, 1.0f, 0.8f);
		}
		return color;
	}

	public static void main(String[] args) {
		(new NonGraphicRunner())
				.openInstance("name.milesparker.infon.InfonModel");
	}
	/**
	 * Gets the Infon Count property for Infon Model.
	 * @return The number of infons to create.
	 */
	public int getInfonCount() {
		return infonCount;
	}

	/**
	 * Sets the Infon Count property for Infon Model.
	 * The number of infons to create.
	 * @param _infonCount the new Infon Count value
	 */
	public void setInfonCount(int _infonCount) {
		infonCount = _infonCount;
	}

	/**
	 * Gets the Dimensions property for Space 2D.
	 * @return The size of each dimension.
	 */
	public int[] getSpace2DDimensions() {
		return space2DDimensions;
	}

	/**
	 * Sets the Dimensions property for Space 2D.
	 * The size of each dimension.
	 * @param _space2DDimensions the new Dimensions value
	 */
	public void setSpace2DDimensions(int[] _space2DDimensions) {
		space2DDimensions = _space2DDimensions;
	}

	/**
	 * Gets the Width property for Space 2D.
	 * @return The horizontal extent of the space.
	 */
	public int getSpace2DWidth() {
		return space2DWidth;
	}

	/**
	 * Sets the Width property for Space 2D.
	 * The horizontal extent of the space.
	 * @param _space2DWidth the new Width value
	 */
	public void setSpace2DWidth(int _space2DWidth) {
		space2DWidth = _space2DWidth;
	}

	/**
	 * Gets the Height property for Space 2D.
	 * @return The vertical extent of the space.
	 */
	public int getSpace2DHeight() {
		return space2DHeight;
	}

	/**
	 * Sets the Height property for Space 2D.
	 * The vertical extent of the space.
	 * @param _space2DHeight the new Height value
	 */
	public void setSpace2DHeight(int _space2DHeight) {
		space2DHeight = _space2DHeight;
	}

	/**
	 * Gets the Space 2D property for Infon Model.
	 * @return 
	 */
	public Scape getSpace2D() {
		return space2D;
	}

	/**
	 * Sets the Space 2D property for Infon Model.
	 * 
	 * @param _space2D the new Space 2D value
	 */
	public void setSpace2D(Scape _space2D) {
		space2D = _space2D;
	}

	public String getName() {
		if (name == null) {
			return "Infon Model " + getUID();
		} else {
			return name;
		}
	}
}
