package name.milesparker.markets;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * Firm Java Implementation.
 * 
 * Generated by AMF for model: Markets.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class Firm extends CellOccupant {

	/**
	 * 
	 */
	private int sharesOutstanding = 0;

	/**
	 * 
	 */
	private double lastEarnings = 0.0;

	/**
	 * 
	 */
	private double lastPrice = 1.0;

	/**
	 * 
	 */
	private int sharesInternal = 50000;

	/**
	 * 
	 */
	private double priceEarningsRatio = 0.0;

	/**
	 * Constructs a new Firm.
	 */
	public Firm() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Firm clone = (Firm) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public Markets getMarkets() {
		return (Markets) getScape().getScape();
	}
	public java.util.List getNetwork() {
		return ((Graph) getMarkets().getInstrumentHolders().getSpace())
				.getNeighborsFor(this);
	}

	/**
	 * Initialize Initialization. Executed once at the beginning of each model run.
	 */
	public void intializeNonFramework() {
		setSharesInternal(getMarkets().getFirmSharesCount());
		double initialFirmValue = initialFirmValue();
		double initialFirmPrice = initialFirmPrice();
		setLastEarnings(initialFirmValue);
		setLastPrice(initialFirmPrice);
	}

	/**
	 * Calculate Initial Firm Value.
	 */
	public double initialFirmValue() {
		double initialFirmValueMinimum = getMarkets()
				.getInitialFirmValueMinimum();
		double initialFirmValueMaximum = getMarkets()
				.getInitialFirmValueMaximum();
		return randomInRange(initialFirmValueMinimum, initialFirmValueMaximum);
	}

	/**
	 * Modify Earnings Rule. Executed every period.
	 */
	public void modifyEarnings() {
		double earningMovementFactor = earningMovementFactor();
		double lastEarningsMultiplyEarningMovementFactor = getLastEarnings()
				* earningMovementFactor;
		setLastEarnings(lastEarningsMultiplyEarningMovementFactor);
	}

	/**
	 * Calculate Earning Movement Factor.
	 */
	public double earningMovementFactor() {
		double earningMovementFactorMinimum = getMarkets()
				.getEarningMovementFactorMinimum();
		double earningMovementFactorMaximum = getMarkets()
				.getEarningMovementFactorMaximum();
		return randomInRange(earningMovementFactorMinimum,
				earningMovementFactorMaximum);
	}

	/**
	 * Offer Shares Initialization. Executed once at the beginning of each model run.
	 */
	public void offerShares() {
		if (getSharesInternal() > 0) {
			int sharesInternalSubtractFirmSharesperInstrument = getSharesInternal()
					- getMarkets().getFirmSharesperInstrument();
			setSharesInternal(sharesInternalSubtractFirmSharesperInstrument);
			Instrument createInstrument = (Instrument) getMarkets()
					.getInstrumentScape().getSpace().newLocation(false);
			createInstrument.setStatus(StatusEnum.held);
			((org.ascape.model.space.Graph) getMarkets().getFirmInstruments()
					.getSpace()).addNeighborSafe(this, createInstrument, false);
			createInstrument.setOfferPrice(getLastPrice());
			createInstrument.setShares(getMarkets()
					.getFirmSharesperInstrument());
			Trader initialTrader = (Trader) getMarkets().getTraderScape()
					.findRandom();
			if (initialTrader != null) {
				((org.ascape.model.space.Graph) getMarkets()
						.getInstrumentHolders().getSpace()).addNeighborSafe(
						initialTrader, createInstrument, false);
				int incrementInstrumentCount = initialTrader
						.getInstrumentCount() + 1;
				initialTrader.setInstrumentCount(incrementInstrumentCount);
				offerShares();
			}
		}
	}

	/**
	 * Calculate Initial Firm Price.
	 */
	public double initialFirmPrice() {
		double initialFirmPriceMinimum = getMarkets()
				.getInitialFirmPriceMinimum();
		double initialFirmPriceMaximum = getMarkets()
				.getInitialFirmPriceMaximum();
		return randomInRange(initialFirmPriceMinimum, initialFirmPriceMaximum);
	}

	/**
	 * Derive Price Earnings Ratio.
	 */
	public double getPriceEarningsRatio() {
		return getLastPrice() / getLastEarnings();
	}

	/**
	 * Clear Offers Rule. Executed every period.
	 */
	public void clearOffers() {
		Conditional firmCondition = new Conditional() {
			private static final long serialVersionUID = 6846144446402098985L;
			public boolean meetsCondition(Object firmCell) {
				if (firmCell instanceof Instrument) {
					Instrument firm = (Instrument) firmCell;
					return (firm.getStatus() == StatusEnum.ask);
				} else {
					return false;
				}
			}
		};
		List firmList = getMarkets().getInstrumentScape().find(firmCondition);
		for (Object nextFirm : firmList) {
			Instrument firm = (Instrument) (Instrument) nextFirm;
			if (firm != null) {
				firm.setStatus(StatusEnum.held);
			}
		}
	}
	/**
	 * Gets the Shares Outstanding property for Firm.
	 * @return 
	 */
	public int getSharesOutstanding() {
		return sharesOutstanding;
	}

	/**
	 * Sets the Shares Outstanding property for Firm.
	 * 
	 * @param _sharesOutstanding the new Shares Outstanding value
	 */
	public void setSharesOutstanding(int _sharesOutstanding) {
		sharesOutstanding = _sharesOutstanding;
	}

	/**
	 * Gets the Last Earnings property for Firm.
	 * @return 
	 */
	public double getLastEarnings() {
		return lastEarnings;
	}

	/**
	 * Sets the Last Earnings property for Firm.
	 * 
	 * @param _lastEarnings the new Last Earnings value
	 */
	public void setLastEarnings(double _lastEarnings) {
		lastEarnings = _lastEarnings;
	}

	/**
	 * Gets the Last Price property for Firm.
	 * @return 
	 */
	public double getLastPrice() {
		return lastPrice;
	}

	/**
	 * Sets the Last Price property for Firm.
	 * 
	 * @param _lastPrice the new Last Price value
	 */
	public void setLastPrice(double _lastPrice) {
		lastPrice = _lastPrice;
	}

	/**
	 * Gets the Shares Internal property for Firm.
	 * @return 
	 */
	public int getSharesInternal() {
		return sharesInternal;
	}

	/**
	 * Sets the Shares Internal property for Firm.
	 * 
	 * @param _sharesInternal the new Shares Internal value
	 */
	public void setSharesInternal(int _sharesInternal) {
		sharesInternal = _sharesInternal;
	}

	public String getName() {
		if (name == null) {
			return "Firm " + getUID();
		} else {
			return name;
		}
	}
}
