package name.milesparker.markets;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * Instrument Java Implementation.
 * 
 * Generated by AMF for model: Markets.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class Instrument extends CellOccupant {

	/**
	 * 
	 */
	private int shares = 0;

	/**
	 * 
	 */
	private StatusEnum status = StatusEnum.ask;

	/**
	 * 
	 */
	private double offerPrice = 0.0;

	/**
	 * 
	 */
	private double totalPrice = 0.0;

	/**
	 * 
	 */
	private double firmPriceEarningsRatio = 0.0;

	/**
	 * Constructs a new Instrument.
	 */
	public Instrument() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Instrument clone = (Instrument) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public Markets getMarkets() {
		return (Markets) getScape().getScape();
	}
	public java.util.List getNetwork() {
		return ((Graph) getMarkets().getInstrumentHolders().getSpace())
				.getNeighborsFor(this);
	}

	/**
	 * Derive Total Price.
	 */
	public double getTotalPrice() {
		return getOfferPrice() * getShares();
	}

	/**
	 * Derive Firm Price Earnings Ratio.
	 */
	public double getFirmPriceEarningsRatio() {
		Conditional offerredFirmCondition = new Conditional() {
			private static final long serialVersionUID = 6846144446402098985L;
			public boolean meetsCondition(Object offerredFirmCell) {
				if (offerredFirmCell instanceof Firm) {
					return true;
				} else {
					return false;
				}
			}
		};
		Firm offerredFirm = (Firm) ((org.ascape.model.space.Discrete) getMarkets()
				.getFirmInstruments().getSpace()).findRandomNeighbor(this,
				offerredFirmCondition);
		if (offerredFirm != null) {
		}
		return 0.0;
	}

	/**
	 * Gets the Shares property for Instrument.
	 * @return 
	 */
	public int getShares() {
		return shares;
	}

	/**
	 * Sets the Shares property for Instrument.
	 * 
	 * @param _shares the new Shares value
	 */
	public void setShares(int _shares) {
		shares = _shares;
	}

	/**
	 * Gets the Status property for Instrument.
	 * @return 
	 */
	public StatusEnum getStatus() {
		return status;
	}

	/**
	 * Sets the Status property for Instrument.
	 * 
	 * @param _status the new Status value
	 */
	public void setStatus(StatusEnum _status) {
		status = _status;
	}

	/**
	 * Gets the Offer Price property for Instrument.
	 * @return 
	 */
	public double getOfferPrice() {
		return offerPrice;
	}

	/**
	 * Sets the Offer Price property for Instrument.
	 * 
	 * @param _offerPrice the new Offer Price value
	 */
	public void setOfferPrice(double _offerPrice) {
		offerPrice = _offerPrice;
	}

	public String getName() {
		if (name == null) {
			return "Instrument " + getUID();
		} else {
			return name;
		}
	}
}
