package name.milesparker.markets;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * Markets Java Implementation.
 * 
 * Generated by AMF for model: Markets.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class Markets extends Scape implements IGraphicsAdapted {

	/**
	 * The number of traders to create.
	 */
	private int traderCount = 10;

	/**
	 * The number of firms to create.
	 */
	private int firmCount = 5;

	/**
	 * 
	 */
	private double initialFirmValueMinimum = 100000;

	/**
	 * 
	 */
	private double initialFirmValueMaximum = 1000000;

	/**
	 * 
	 */
	private double earningMovementFactorMinimum = .99;

	/**
	 * 
	 */
	private double earningMovementFactorMaximum = 1.01;

	/**
	 * 
	 */
	private int firmSharesperInstrument = 1000;

	/**
	 * 
	 */
	private double sharePriceAdjustmentMinimum = .98;

	/**
	 * 
	 */
	private double sharePriceAdjustmentMaximum = 1.02;

	/**
	 * 
	 */
	private double initialFirmPriceMinimum = 10.0;

	/**
	 * 
	 */
	private double initialFirmPriceMaximum = 30.0;

	/**
	 * 
	 */
	private double initialTraderFundsMinimum = 50000;

	/**
	 * 
	 */
	private double initialTraderFundsMaximum = 50000;

	/**
	 * 
	 */
	private int firmSharesCount = 10000;

	/**
	 * 
	 */
	private Scape instrumentHolders = null;

	/**
	 * 
	 */
	private Scape firmInstruments = null;

	/**
	 * 
	 */
	private Scape targetBuyFirms = null;

	/**
	 * Constructs a new Markets.
	 */
	public Markets() {
	}

	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Markets clone = (Markets) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	org.ascape.model.Scape traderScape;
	org.ascape.model.Scape firmScape;
	org.ascape.model.Scape instrumentScape;

	/**
	 * Create an instance of Trader that will be used to populate the traderScape.
	 * Overide to customize the prototype, for example to change the views created for a member scape.
	 */
	protected Trader createTraderPrototype() {
		return new Trader();
	}
	/**
	 * Create an instance of Firm that will be used to populate the firmScape.
	 * Overide to customize the prototype, for example to change the views created for a member scape.
	 */
	protected Firm createFirmPrototype() {
		return new Firm();
	}
	/**
	 * Create an instance of Instrument that will be used to populate the instrumentScape.
	 * Overide to customize the prototype, for example to change the views created for a member scape.
	 */
	protected Instrument createInstrumentPrototype() {
		return new Instrument();
	}

	static int next_vm_id;

	int vm_unique_id;

	/**
	 * Creates the members of Markets. 
	 */
	public void createScape() {
		super.createScape();

		setName("Markets");
		Trader traderProto = createTraderPrototype();
		traderScape = new Scape();
		traderScape.setName("Traders");
		traderScape.setPrototypeAgent(traderProto);
		traderScape.setExecutionOrder(Scape.RULE_ORDER);
		Firm firmProto = createFirmPrototype();
		firmScape = new Scape();
		firmScape.setName("Firms");
		firmScape.setPrototypeAgent(firmProto);
		firmScape.setExecutionOrder(Scape.RULE_ORDER);
		Instrument instrumentProto = createInstrumentPrototype();
		instrumentScape = new Scape();
		instrumentScape.setName("Instruments");
		instrumentScape.setPrototypeAgent(instrumentProto);
		instrumentScape.setExecutionOrder(Scape.RULE_ORDER);
		traderScape.setSize(traderCount);
		firmScape.setSize(firmCount);
		instrumentHolders = new Scape(new org.ascape.model.space.Graph());
		instrumentHolders.setName("InstrumentHolderss");
		add(instrumentHolders);
		firmInstruments = new Scape(new org.ascape.model.space.Graph());
		firmInstruments.setName("FirmInstrumentss");
		add(firmInstruments);
		targetBuyFirms = new Scape(new org.ascape.model.space.Graph());
		targetBuyFirms.setName("Target Buy Firmss");
		add(targetBuyFirms);

		add(traderScape);

		add(firmScape);

		add(instrumentScape);

		traderScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCond(
						getName() + " Population") {
					private static final long serialVersionUID = 684614444640209893L;

					@SuppressWarnings("unused")
					public final boolean meetsCondition(Object object) {
						return true;
					}
				});
		traderScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
						"Trader Funds") {
					private static final long serialVersionUID = 6846144446402098985L;
					public final double getValue(Object trader) {
						return ((Trader) trader).getFunds();
					}
				});

		traderScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
						"Trader Instrument Count") {
					private static final long serialVersionUID = 6846144446402098985L;
					public final double getValue(Object trader) {
						return ((Trader) trader).getInstrumentCount();
					}
				});

		firmScape.addStatCollector(new org.ascape.util.data.StatCollectorCond(
				getName() + " Population") {
			private static final long serialVersionUID = 684614444640209893L;

			@SuppressWarnings("unused")
			public final boolean meetsCondition(Object object) {
				return true;
			}
		});
		firmScape.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
				"Firm Shares Outstanding") {
			private static final long serialVersionUID = 6846144446402098985L;
			public final double getValue(Object firm) {
				return ((Firm) firm).getSharesOutstanding();
			}
		});

		firmScape.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
				"Firm Last Earnings") {
			private static final long serialVersionUID = 6846144446402098985L;
			public final double getValue(Object firm) {
				return ((Firm) firm).getLastEarnings();
			}
		});

		firmScape.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
				"Firm Last Price") {
			private static final long serialVersionUID = 6846144446402098985L;
			public final double getValue(Object firm) {
				return ((Firm) firm).getLastPrice();
			}
		});

		firmScape.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
				"Firm Shares Internal") {
			private static final long serialVersionUID = 6846144446402098985L;
			public final double getValue(Object firm) {
				return ((Firm) firm).getSharesInternal();
			}
		});

		instrumentScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCond(
						getName() + " Population") {
					private static final long serialVersionUID = 684614444640209893L;

					@SuppressWarnings("unused")
					public final boolean meetsCondition(Object object) {
						return true;
					}
				});
		instrumentScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCond(
						"Instrument Ask Status") {
					private static final long serialVersionUID = 6846144446402098985L;
					public final boolean meetsCondition(Object instrument) {
						return StatusEnum.ask == ((Instrument) instrument)
								.getStatus();
					}
				});

		instrumentScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCond(
						"Instrument Held Status") {
					private static final long serialVersionUID = 6846144446402098985L;
					public final boolean meetsCondition(Object instrument) {
						return StatusEnum.held == ((Instrument) instrument)
								.getStatus();
					}
				});

		instrumentScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCond(
						"Instrument Bid Status") {
					private static final long serialVersionUID = 6846144446402098985L;
					public final boolean meetsCondition(Object instrument) {
						return StatusEnum.bid == ((Instrument) instrument)
								.getStatus();
					}
				});

		instrumentScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
						"Instrument Offer Price") {
					private static final long serialVersionUID = 6846144446402098985L;
					public final double getValue(Object instrument) {
						return ((Instrument) instrument).getOfferPrice();
					}
				});

		instrumentScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCSAMM(
						"Instrument Total Price") {
					private static final long serialVersionUID = 6846144446402098985L;
					public final double getValue(Object instrument) {
						return ((Instrument) instrument).getTotalPrice();
					}
				});

		traderScape.addInitialRule(new Rule("Initialize") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((name.milesparker.markets.Trader) a).intializeNonFramework();
			}
		});
		traderScape.addRule(new Rule("Ask") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((name.milesparker.markets.Trader) a).ask();
			}
		});
		traderScape.addRule(new Rule("Buy") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((name.milesparker.markets.Trader) a).buy();
			}
		});
		traderScape.addRule(new Rule("Execute") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((name.milesparker.markets.Trader) a).execute();
			}
		});

		firmScape.addInitialRule(new Rule("Initialize") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((name.milesparker.markets.Firm) a).intializeNonFramework();
			}
		});
		firmScape.addRule(new Rule("Modify Earnings") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((name.milesparker.markets.Firm) a).modifyEarnings();
			}
		});

		firmScape.addInitialRule(new Rule("Offer Shares") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((name.milesparker.markets.Firm) a).offerShares();
			}
		});
		firmScape.addRule(new Rule("Clear Offers") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((name.milesparker.markets.Firm) a).clearOffers();
			}
		});

	}

	/**
	 * Creates UI views for Markets.
	 */
	public void createGraphicViews() {
		super.createGraphicViews();
		ChartView chart = new ChartView();

		final Markets traderScape = new Markets();
		traderScape.setRunner(new NonGraphicRunner());
		Trader trader = new Trader() {
			public void requestUpdate() {
			}
			public Markets getMarkets() {
				return traderScape;
			}
		};
		traderScape.add(trader);
		HostCell traderHost = new HostCell() {
			public void requestUpdate() {
			}
		};
		traderHost.setOccupant((CellOccupant) trader);

		IColorProvider traderStyle2DColorProvider = new TraderStyle2DColorProvider();

		final Markets firmScape = new Markets();
		firmScape.setRunner(new NonGraphicRunner());
		Firm firm = new Firm() {
			public void requestUpdate() {
			}
			public Markets getMarkets() {
				return firmScape;
			}
		};
		firmScape.add(firm);
		HostCell firmHost = new HostCell() {
			public void requestUpdate() {
			}
		};
		firmHost.setOccupant((CellOccupant) firm);

		IColorProvider firmStyle2DColorProvider = new FirmStyle2DColorProvider();

		final Markets instrumentScape = new Markets();
		instrumentScape.setRunner(new NonGraphicRunner());
		Instrument instrument = new Instrument() {
			public void requestUpdate() {
			}
			public Markets getMarkets() {
				return instrumentScape;
			}
		};
		instrumentScape.add(instrument);
		HostCell instrumentHost = new HostCell() {
			public void requestUpdate() {
			}
		};
		instrumentHost.setOccupant((CellOccupant) instrument);

		IColorProvider instrumentStyle2DColorProvider = new InstrumentStyle2DColorProvider();

		instrument.setStatus(StatusEnum.ask);
		chart.addSeries(
				"Count Instrument Ask Status",
				getInferredChartColor(instrument,
						instrumentStyle2DColorProvider));

		instrument.setStatus(StatusEnum.held);
		chart.addSeries(
				"Count Instrument Held Status",
				getInferredChartColor(instrument,
						instrumentStyle2DColorProvider));

		instrument.setStatus(StatusEnum.bid);
		chart.addSeries(
				"Count Instrument Bid Status",
				getInferredChartColor(instrument,
						instrumentStyle2DColorProvider));
		addView(chart);
		addView(new GraphView());
	}

	public void scapeSetup(ScapeEvent scapeEvent) {
		//Set the size of the scape populations, e.g. for mutable scapes that need to have their size reset

		traderScape.setSize(traderCount);
		firmScape.setSize(firmCount);
	}

	/**
	 * Returns the Scape containing Traders.
	 */
	public org.ascape.model.Scape getTraderScape() {
		return traderScape;
	}
	/**
	 * Returns the Scape containing Firms.
	 */
	public org.ascape.model.Scape getFirmScape() {
		return firmScape;
	}
	/**
	 * Returns the Scape containing Instruments.
	 */
	public org.ascape.model.Scape getInstrumentScape() {
		return instrumentScape;
	}

	public IGraphicsAdapter getGraphicsAdapter() {
		return MarketsGraphicsAdapter.getDefault();
	}

	private Color getInferredChartColor(Object agent,
			IColorProvider colorProvider) {
		Color color = colorProvider.getForeground(agent);
		if (color == ColorFeature.BLACK) {
			color = ColorFeatureConcrete.createHSB(
					(float) java.lang.Math.random() * 360f, 1.0f, 0.8f);
		}
		return color;
	}

	public static void main(String[] args) {
		(new NonGraphicRunner())
				.openInstance("name.milesparker.markets.Markets");
	}
	/**
	 * Gets the Trader Count property for Markets.
	 * @return The number of traders to create.
	 */
	public int getTraderCount() {
		return traderCount;
	}

	/**
	 * Sets the Trader Count property for Markets.
	 * The number of traders to create.
	 * @param _traderCount the new Trader Count value
	 */
	public void setTraderCount(int _traderCount) {
		traderCount = _traderCount;
	}

	/**
	 * Gets the Firm Count property for Markets.
	 * @return The number of firms to create.
	 */
	public int getFirmCount() {
		return firmCount;
	}

	/**
	 * Sets the Firm Count property for Markets.
	 * The number of firms to create.
	 * @param _firmCount the new Firm Count value
	 */
	public void setFirmCount(int _firmCount) {
		firmCount = _firmCount;
	}

	/**
	 * Gets the Initial Firm Value Minimum property for Markets.
	 * @return 
	 */
	public double getInitialFirmValueMinimum() {
		return initialFirmValueMinimum;
	}

	/**
	 * Sets the Initial Firm Value Minimum property for Markets.
	 * 
	 * @param _initialFirmValueMinimum the new Initial Firm Value Minimum value
	 */
	public void setInitialFirmValueMinimum(double _initialFirmValueMinimum) {
		initialFirmValueMinimum = _initialFirmValueMinimum;
	}

	/**
	 * Gets the Initial Firm Value Maximum property for Markets.
	 * @return 
	 */
	public double getInitialFirmValueMaximum() {
		return initialFirmValueMaximum;
	}

	/**
	 * Sets the Initial Firm Value Maximum property for Markets.
	 * 
	 * @param _initialFirmValueMaximum the new Initial Firm Value Maximum value
	 */
	public void setInitialFirmValueMaximum(double _initialFirmValueMaximum) {
		initialFirmValueMaximum = _initialFirmValueMaximum;
	}

	/**
	 * Gets the Earning Movement Factor Minimum property for Markets.
	 * @return 
	 */
	public double getEarningMovementFactorMinimum() {
		return earningMovementFactorMinimum;
	}

	/**
	 * Sets the Earning Movement Factor Minimum property for Markets.
	 * 
	 * @param _earningMovementFactorMinimum the new Earning Movement Factor Minimum value
	 */
	public void setEarningMovementFactorMinimum(
			double _earningMovementFactorMinimum) {
		earningMovementFactorMinimum = _earningMovementFactorMinimum;
	}

	/**
	 * Gets the Earning Movement Factor Maximum property for Markets.
	 * @return 
	 */
	public double getEarningMovementFactorMaximum() {
		return earningMovementFactorMaximum;
	}

	/**
	 * Sets the Earning Movement Factor Maximum property for Markets.
	 * 
	 * @param _earningMovementFactorMaximum the new Earning Movement Factor Maximum value
	 */
	public void setEarningMovementFactorMaximum(
			double _earningMovementFactorMaximum) {
		earningMovementFactorMaximum = _earningMovementFactorMaximum;
	}

	/**
	 * Gets the Firm Shares per Instrument property for Markets.
	 * @return 
	 */
	public int getFirmSharesperInstrument() {
		return firmSharesperInstrument;
	}

	/**
	 * Sets the Firm Shares per Instrument property for Markets.
	 * 
	 * @param _firmSharesperInstrument the new Firm Shares per Instrument value
	 */
	public void setFirmSharesperInstrument(int _firmSharesperInstrument) {
		firmSharesperInstrument = _firmSharesperInstrument;
	}

	/**
	 * Gets the Share Price Adjustment Minimum property for Markets.
	 * @return 
	 */
	public double getSharePriceAdjustmentMinimum() {
		return sharePriceAdjustmentMinimum;
	}

	/**
	 * Sets the Share Price Adjustment Minimum property for Markets.
	 * 
	 * @param _sharePriceAdjustmentMinimum the new Share Price Adjustment Minimum value
	 */
	public void setSharePriceAdjustmentMinimum(
			double _sharePriceAdjustmentMinimum) {
		sharePriceAdjustmentMinimum = _sharePriceAdjustmentMinimum;
	}

	/**
	 * Gets the Share Price Adjustment Maximum property for Markets.
	 * @return 
	 */
	public double getSharePriceAdjustmentMaximum() {
		return sharePriceAdjustmentMaximum;
	}

	/**
	 * Sets the Share Price Adjustment Maximum property for Markets.
	 * 
	 * @param _sharePriceAdjustmentMaximum the new Share Price Adjustment Maximum value
	 */
	public void setSharePriceAdjustmentMaximum(
			double _sharePriceAdjustmentMaximum) {
		sharePriceAdjustmentMaximum = _sharePriceAdjustmentMaximum;
	}

	/**
	 * Gets the Initial Firm Price Minimum property for Markets.
	 * @return 
	 */
	public double getInitialFirmPriceMinimum() {
		return initialFirmPriceMinimum;
	}

	/**
	 * Sets the Initial Firm Price Minimum property for Markets.
	 * 
	 * @param _initialFirmPriceMinimum the new Initial Firm Price Minimum value
	 */
	public void setInitialFirmPriceMinimum(double _initialFirmPriceMinimum) {
		initialFirmPriceMinimum = _initialFirmPriceMinimum;
	}

	/**
	 * Gets the Initial Firm Price Maximum property for Markets.
	 * @return 
	 */
	public double getInitialFirmPriceMaximum() {
		return initialFirmPriceMaximum;
	}

	/**
	 * Sets the Initial Firm Price Maximum property for Markets.
	 * 
	 * @param _initialFirmPriceMaximum the new Initial Firm Price Maximum value
	 */
	public void setInitialFirmPriceMaximum(double _initialFirmPriceMaximum) {
		initialFirmPriceMaximum = _initialFirmPriceMaximum;
	}

	/**
	 * Gets the Initial Trader Funds Minimum property for Markets.
	 * @return 
	 */
	public double getInitialTraderFundsMinimum() {
		return initialTraderFundsMinimum;
	}

	/**
	 * Sets the Initial Trader Funds Minimum property for Markets.
	 * 
	 * @param _initialTraderFundsMinimum the new Initial Trader Funds Minimum value
	 */
	public void setInitialTraderFundsMinimum(double _initialTraderFundsMinimum) {
		initialTraderFundsMinimum = _initialTraderFundsMinimum;
	}

	/**
	 * Gets the Initial Trader Funds Maximum property for Markets.
	 * @return 
	 */
	public double getInitialTraderFundsMaximum() {
		return initialTraderFundsMaximum;
	}

	/**
	 * Sets the Initial Trader Funds Maximum property for Markets.
	 * 
	 * @param _initialTraderFundsMaximum the new Initial Trader Funds Maximum value
	 */
	public void setInitialTraderFundsMaximum(double _initialTraderFundsMaximum) {
		initialTraderFundsMaximum = _initialTraderFundsMaximum;
	}

	/**
	 * Gets the Firm Shares Count property for Markets.
	 * @return 
	 */
	public int getFirmSharesCount() {
		return firmSharesCount;
	}

	/**
	 * Sets the Firm Shares Count property for Markets.
	 * 
	 * @param _firmSharesCount the new Firm Shares Count value
	 */
	public void setFirmSharesCount(int _firmSharesCount) {
		firmSharesCount = _firmSharesCount;
	}

	/**
	 * Gets the InstrumentHolders property for Markets.
	 * @return 
	 */
	public Scape getInstrumentHolders() {
		return instrumentHolders;
	}

	/**
	 * Sets the InstrumentHolders property for Markets.
	 * 
	 * @param _instrumentHolders the new InstrumentHolders value
	 */
	public void setInstrumentHolders(Scape _instrumentHolders) {
		instrumentHolders = _instrumentHolders;
	}

	/**
	 * Gets the FirmInstruments property for Markets.
	 * @return 
	 */
	public Scape getFirmInstruments() {
		return firmInstruments;
	}

	/**
	 * Sets the FirmInstruments property for Markets.
	 * 
	 * @param _firmInstruments the new FirmInstruments value
	 */
	public void setFirmInstruments(Scape _firmInstruments) {
		firmInstruments = _firmInstruments;
	}

	/**
	 * Gets the Target Buy Firms property for Markets.
	 * @return 
	 */
	public Scape getTargetBuyFirms() {
		return targetBuyFirms;
	}

	/**
	 * Sets the Target Buy Firms property for Markets.
	 * 
	 * @param _targetBuyFirms the new Target Buy Firms value
	 */
	public void setTargetBuyFirms(Scape _targetBuyFirms) {
		targetBuyFirms = _targetBuyFirms;
	}

	public String getName() {
		if (name == null) {
			return "Markets " + getUID();
		} else {
			return name;
		}
	}
}
