package org.eclipse.amp.amf.examples.escape;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * Individual Java Implementation.
 * 
 * Generated by AMF for model: WikiExample.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class Individual extends CellOccupant {

	/**
	 * 
	 */
	private int age = 0;

	/**
	 * 
	 */
	private int vision = 5;

	/**
	 * 
	 */
	private double wealth = 0.0;

	/**
	 * Constructs a new Individual.
	 */
	public Individual() {
	}
	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			Individual clone = (Individual) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	public WikiExample getWikiExample() {
		return (WikiExample) getScape().getScape();
	}

	/**
	 * Find Partner Rule. Executed every period.
	 */
	public void findPartner() {
		Conditional partnerCondition = new Conditional() {
			private static final long serialVersionUID = 6846144446402098985L;
			public boolean meetsCondition(Object partnerCell) {
				partnerCell = ((org.ascape.model.HostCell) partnerCell)
						.getOccupant();
				if (partnerCell instanceof Individual) {
					Individual partner = (Individual) partnerCell;
					return (getAge() == partner.getAge());
				} else {
					return false;
				}
			}
		};
		Location partnerLocation = ((org.ascape.model.space.Discrete) getWikiExample()
				.getCity().getSpace()).findRandomWithin(
				((org.ascape.model.CellOccupant) this).getHostCell(),
				partnerCondition, false, getVision());
		if (partnerLocation != null) {
			Individual partner = (Individual) ((org.ascape.model.HostCell) partnerLocation)
					.getOccupant();
			if (partner != null) {
				Block partnerNeighbor = (Block) ((org.ascape.model.space.Discrete) partner
						.getWikiExample().getCity().getSpace())
						.findRandomAvailableNeighbor(((org.ascape.model.CellOccupant) partner)
								.getHostCell());
				if (partnerNeighbor != null) {
					if (getHostScape() != ((Agent) partnerNeighbor).getScape()) {
						die();
						getWikiExample().getIndividualScape().add(this);
					}
					moveTo(partnerNeighbor);
				}
			}
		}
	}

	/**
	 * Initial State Initialization. Executed once at the beginning of each model run.
	 */
	public void initialState() {
		int initialStateRandomToLimit_MaximumAge_ = randomToLimit(getWikiExample()
				.getMaximumAge());
		double initialStateRandomUnit = getRandom().nextDouble();
		setAge(initialStateRandomToLimit_MaximumAge_);
		setWealth(initialStateRandomUnit);
	}

	/**
	 * Initial Movement Initialization. Executed once at the beginning of each model run.
	 */
	public void initialMovement() {
		Block individual = (Block) ((org.ascape.model.space.Discrete) getWikiExample()
				.getCity().getSpace()).findRandomAvailable();
		if (individual != null) {
			if (getHostScape() != ((Agent) individual).getScape()) {
				die();
				getWikiExample().getIndividualScape().add(this);
			}
			moveTo(individual);
		}
	}
	/**
	 * Gets the Age property for Individual.
	 * @return 
	 */
	public int getAge() {
		return age;
	}

	/**
	 * Sets the Age property for Individual.
	 * 
	 * @param _age the new Age value
	 */
	public void setAge(int _age) {
		age = _age;
	}

	/**
	 * Gets the Vision property for Individual.
	 * @return 
	 */
	public int getVision() {
		return vision;
	}

	/**
	 * Sets the Vision property for Individual.
	 * 
	 * @param _vision the new Vision value
	 */
	public void setVision(int _vision) {
		vision = _vision;
	}

	/**
	 * Gets the Wealth property for Individual.
	 * @return 
	 */
	public double getWealth() {
		return wealth;
	}

	/**
	 * Sets the Wealth property for Individual.
	 * 
	 * @param _wealth the new Wealth value
	 */
	public void setWealth(double _wealth) {
		wealth = _wealth;
	}

	public String getName() {
		if (name == null) {
			return "Individual " + getUID();
		} else {
			return name;
		}
	}
}
