package org.eclipse.amp.amf.examples.escape;

import java.util.List;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.amp.agf.IGraphicsAdapted;
import org.eclipse.amp.agf.IGraphicsAdapter;

import org.eclipse.swt.graphics.Color;
import org.eclipse.jface.viewers.IColorProvider;

import org.ascape.model.Agent;
import org.ascape.model.Cell;
import org.ascape.model.CellOccupant;
import org.ascape.model.HostCell;
import org.ascape.model.LocatedAgent;
import org.ascape.model.Scape;
import org.ascape.model.event.ScapeEvent;
import org.ascape.model.rule.Rule;
import org.ascape.model.rule.ExecuteThenUpdate;
import org.ascape.model.space.CollectionSpace;
import org.ascape.model.space.Coordinate;
import org.ascape.model.space.Coordinate2DDiscrete;
import org.ascape.model.space.Graph;
import org.ascape.model.space.Location;
import org.ascape.runtime.NonGraphicRunner;
import org.ascape.util.Conditional;
import org.ascape.util.data.DataPoint;
import org.ascape.util.data.DataPointConcrete;
import org.ascape.util.vis.ColorFeature;
import org.ascape.util.vis.ColorFeatureConcrete;
import org.ascape.view.vis.ChartView;
import org.ascape.view.vis.GEFView;
import org.ascape.view.vis.GraphView;

/**
 * WikiExample Java Implementation.
 * 
 * Generated by AMF for model: WikiExample.metaabm in project: org.eclipse.amp.amf.examples.escape 
 */
public class WikiExample extends Scape implements IGraphicsAdapted {

	/**
	 * The number of individuals to create.
	 */
	private int individualCount = 50;

	/**
	 * 
	 */
	private int maximumAge = 10;

	/**
	 * 
	 */
	private double maximumWealth = 0.0;

	/**
	 * The size of each dimension.
	 */
	private int[] cityDimensions = new int[2];

	/**
	 * The horizontal extent of the space.
	 */
	private int cityWidth = 20;

	/**
	 * The vertical extent of the space.
	 */
	private int cityHeight = 20;

	/**
	 * 
	 */
	private Scape city = null;

	/**
	 * Constructs a new WikiExample.
	 */
	public WikiExample() {
	}

	//todo, make this a useful value for evaluating compatibility of different versions of generated classes
	private static final long serialVersionUID = 89989998L;

	private static long nextUniqueID;

	private long uniqueID;

	public long getUID() {
		if (uniqueID == 0) {
			uniqueID = nextUniqueID++;
		}
		return uniqueID;
	}

	/**
	 * Clones the agent, ensuring that a unique id is assigned.
	 */
	public Object clone() {
		try {
			WikiExample clone = (WikiExample) super.clone();
			clone.uniqueID = 0;
			return clone;
		} catch (Exception e) {
			throw new RuntimeException("Unexpected cloning exception: " + e);
		}
	}

	org.ascape.model.Scape individualScape;

	/**
	 * Create an instance of Individual that will be used to populate the individualScape.
	 * Overide to customize the prototype, for example to change the views created for a member scape.
	 */
	protected Individual createIndividualPrototype() {
		return new Individual();
	}

	static int next_vm_id;

	int vm_unique_id;

	/**
	 * Creates the members of WikiExample. 
	 */
	public void createScape() {
		super.createScape();

		setName("WikiExample");
		Individual individualProto = createIndividualPrototype();
		individualScape = new Scape();
		individualScape.setName("Individuals");
		individualScape.setPrototypeAgent(individualProto);
		individualScape.setExecutionOrder(Scape.RULE_ORDER);

		individualScape.setSize(individualCount);
		city = new Scape(new org.ascape.model.space.Array2DMoore());
		city.setExecutionOrder(Scape.RULE_ORDER);
		city.setPrototypeAgent(new Block());
		city.setExtent(new org.ascape.model.space.Coordinate2DDiscrete(
				getCityWidth(), getCityHeight()));

		city.setName("Citys");
		((CollectionSpace) city.getSpace()).setPeriodic(false);
		add(city);
		org.ascape.model.Scape blockScape = city;

		add(individualScape);

		individualProto.setHostScape(city);
		city.getRules().clear();

		individualScape
				.addStatCollector(new org.ascape.util.data.StatCollectorCond(
						getName() + " Population") {
					private static final long serialVersionUID = 684614444640209893L;

					@SuppressWarnings("unused")
					public final boolean meetsCondition(Object object) {
						return true;
					}
				});

		individualScape.addRule(new Rule("Find Partner") {
			private static final long serialVersionUID = 6846144446402098981L;
			public void execute(Agent a) {
				((org.eclipse.amp.amf.examples.escape.Individual) a)
						.findPartner();
			}
		});

		individualScape.addInitialRule(new Rule("Initial State") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((org.eclipse.amp.amf.examples.escape.Individual) a)
						.initialState();
			}
		});

		individualScape.addInitialRule(new Rule("Initial Movement") {
			private static final long serialVersionUID = 6846144446402098982L;
			public void execute(Agent a) {
				((org.eclipse.amp.amf.examples.escape.Individual) a)
						.initialMovement();
			}
		});

	}

	/**
	 * Creates UI views for WikiExample.
	 */
	public void createGraphicViews() {
		super.createGraphicViews();
		ChartView chart = new ChartView();

		final WikiExample individualScape = new WikiExample();
		individualScape.setRunner(new NonGraphicRunner());
		Individual individual = new Individual() {
			public void requestUpdate() {
			}
			public WikiExample getWikiExample() {
				return individualScape;
			}
		};
		individualScape.add(individual);
		HostCell individualHost = new HostCell() {
			public void requestUpdate() {
			}
		};
		individualHost.setOccupant((CellOccupant) individual);

		IColorProvider simpleDrawColorProvider = new SimpleDrawColorProvider();

		addView(chart);
		addView(new GEFView());
	}

	public void scapeSetup(ScapeEvent scapeEvent) {
		//Set the size of the scape populations, e.g. for mutable scapes that need to have their size reset

		individualScape.setSize(individualCount);
	}

	/**
	 * Returns the Scape containing Individuals.
	 */
	public org.ascape.model.Scape getIndividualScape() {
		return individualScape;
	}

	public IGraphicsAdapter getGraphicsAdapter() {
		return WikiExampleGraphicsAdapter.getDefault();
	}

	private Color getInferredChartColor(Object agent,
			IColorProvider colorProvider) {
		Color color = colorProvider.getForeground(agent);
		if (color == ColorFeature.BLACK) {
			color = ColorFeatureConcrete.createHSB(
					(float) java.lang.Math.random() * 360f, 1.0f, 0.8f);
		}
		return color;
	}

	public static void main(String[] args) {
		(new NonGraphicRunner())
				.openInstance("org.eclipse.amp.amf.examples.escape.WikiExample");
	}
	/**
	 * Gets the Individual Count property for WikiExample.
	 * @return The number of individuals to create.
	 */
	public int getIndividualCount() {
		return individualCount;
	}

	/**
	 * Sets the Individual Count property for WikiExample.
	 * The number of individuals to create.
	 * @param _individualCount the new Individual Count value
	 */
	public void setIndividualCount(int _individualCount) {
		individualCount = _individualCount;
	}

	/**
	 * Gets the Maximum Age property for WikiExample.
	 * @return 
	 */
	public int getMaximumAge() {
		return maximumAge;
	}

	/**
	 * Sets the Maximum Age property for WikiExample.
	 * 
	 * @param _maximumAge the new Maximum Age value
	 */
	public void setMaximumAge(int _maximumAge) {
		maximumAge = _maximumAge;
	}

	/**
	 * Gets the Maximum Wealth property for WikiExample.
	 * @return 
	 */
	public double getMaximumWealth() {
		return maximumWealth;
	}

	/**
	 * Sets the Maximum Wealth property for WikiExample.
	 * 
	 * @param _maximumWealth the new Maximum Wealth value
	 */
	public void setMaximumWealth(double _maximumWealth) {
		maximumWealth = _maximumWealth;
	}

	/**
	 * Gets the Dimensions property for City.
	 * @return The size of each dimension.
	 */
	public int[] getCityDimensions() {
		return cityDimensions;
	}

	/**
	 * Sets the Dimensions property for City.
	 * The size of each dimension.
	 * @param _cityDimensions the new Dimensions value
	 */
	public void setCityDimensions(int[] _cityDimensions) {
		cityDimensions = _cityDimensions;
	}

	/**
	 * Gets the Width property for City.
	 * @return The horizontal extent of the space.
	 */
	public int getCityWidth() {
		return cityWidth;
	}

	/**
	 * Sets the Width property for City.
	 * The horizontal extent of the space.
	 * @param _cityWidth the new Width value
	 */
	public void setCityWidth(int _cityWidth) {
		cityWidth = _cityWidth;
	}

	/**
	 * Gets the Height property for City.
	 * @return The vertical extent of the space.
	 */
	public int getCityHeight() {
		return cityHeight;
	}

	/**
	 * Sets the Height property for City.
	 * The vertical extent of the space.
	 * @param _cityHeight the new Height value
	 */
	public void setCityHeight(int _cityHeight) {
		cityHeight = _cityHeight;
	}

	/**
	 * Gets the City property for WikiExample.
	 * @return 
	 */
	public Scape getCity() {
		return city;
	}

	/**
	 * Sets the City property for WikiExample.
	 * 
	 * @param _city the new City value
	 */
	public void setCity(Scape _city) {
		city = _city;
	}

	public String getName() {
		if (name == null) {
			return "WikiExample " + getUID();
		} else {
			return name;
		}
	}
}
