package org.metaabm.gen.test;

import org.apache.commons.lang.RandomStringUtils;

import junit.framework.TestCase;

import repast.parameter.Parameter;

/**
 * Area Java Implementation.
 *
 *
 * Generated by metaabm system: Nov 1, 2007 5:24:24 PM PDT
 */
public class Area extends TestCase {

    /**
     * Most recent version.
     */
    private static ActModel model;

    /**
     *
     */
    private boolean goal;

    /**
     *
     */
    private boolean nearGoal;
    private String uniqueID;

    /**
     * Constructs a new Area.
     */
    public Area() {
        createUniqueID();
    }

    /**
     * Gets the Goal property for Area.
     * @return
     */
    @Parameter(displayName = "Goal", usageName = "goal", defaultValue = "")
    public boolean isGoal() {
        return goal;
    }

    /**
     * Sets the Goal property for Area.
     *
     * @param _goal the new Goal value
     */
    public void setGoal(boolean _goal) {
        goal = _goal;

    }

    /**
     * Gets the Near Goal property for Area.
     * @return
     */
    @Parameter(displayName = "Near Goal", usageName = "nearGoal", defaultValue = "")
    public boolean isNearGoal() {
        return nearGoal;
    }

    /**
     * Sets the Near Goal property for Area.
     *
     * @param _nearGoal the new Near Goal value
     */
    public void setNearGoal(boolean _nearGoal) {
        nearGoal = _nearGoal;

    }

    /**
     * Gets the Act Model property for Named.
     * @return Most recent version.
     */
    public static ActModel getActModel() {
        return model;
    }

    /**
     * Sets the Act Model property for Named.
     * Most recent version.
     * @param _actModel the new Act Model value
     */
    public static void setActModel(ActModel _actModel) {
        model = _actModel;

    }

    public String getUID() {
        return uniqueID;
    }

    public String toString() {
        return "Area " + uniqueID;
    }

    public void createUniqueID() {
        uniqueID = RandomStringUtils.randomAlphanumeric(5);
    }

    /**
     * Clones the agent, ensuring that a unique id is assigned.
     */
    public Object clone() {
        try {
            Area clone = (Area) super.clone();
            clone.createUniqueID();
            return clone;
        } catch (Exception e) {
            throw new RuntimeException("Unexpected cloning exception: " + e);
        }
    }
}
